/*--------------------------------------------------------------*/
//Ƶʼ
//Ƭ:	STC89C52RC
//ʱģʽ:	6T/˫
//:		24MHz
//Ƶ: 1.9MHz
//:	1Hz
//,Բ߾
//74HC393Ƶ󣬿ԲƵ40MHzңΪ32Hz
//ѡ74HC151

/*--------------------------------------------------------------*/
#include <at89x52.h>
#include "LCD1602_8A.H"
sbit Key = P1^3;	//
sfr  sel = 0x80;

/*--------------------------------------------------------------*/
unsigned char dat[8];		//ʾ
unsigned char i, counter;	//ѭͼ
unsigned int  num;			//ʱ
unsigned long x, y;			//Ƶʱ
unsigned char k_val;		//


/*--------------------------------------------------------------*/
//ʼ
void counter_data_init(void)
{
	counter = 0;
	num = 0;
	for(i = 0; i < 8; i++)	dat[i] = 0;
	i = 0;
}


/*--------------------------------------------------------------*/
//ʱ1.25s 
void delay1_25s(void)
{
	unsigned char i, j, k;
	for(i = 189; i > 0; i--)
	for(j = 68;  j > 0; j--)
	for(k = 193; k > 0; k--);
}


/*--------------------------------------------------------------*/
//ʱ5ms 
void delay5ms(void)
{
    unsigned char i, j;
    for(i = 215; i > 0; i--)
    for(j = 45; j > 0; j--);
}


/*--------------------------------------------------------------*/
//
void key_pro(void)
{
	if(Key == 0)
	{
		delay5ms();
		if(Key == 0)
		{
			k_val++;
			if(k_val > 5) k_val = 0;
			LCD_printc(15, 1, k_val+48);
		}
		while(Key == 0);
	}
	sel = k_val;
}


/*--------------------------------------------------------------*/
//ʱʼ
void ct_mode_init(void)
{
	TMOD = 0x25;				// T0T1ʱ

	TH0 = 0x00;	 TL0 = 0x00;
	TH1 = 0x06;	 TL1 = 0x06;
	ET0 = 1;	 ET1 = 1;
	EA  = 1;
	TR0 = 1;	 TR1 = 1;
}


/*--------------------------------------------------------------*/
//
void main(void)
{
	LCD_init();
	LCD_prints(2, 0, "System is");
	LCD_prints(0, 1, "Initializing...");
	delay1_25s();
	LCD_clr();
	LCD_prints(0,  0, "T:");
	LCD_prints(12, 0, "ns");
	LCD_prints(0,  1, "F:");
	LCD_prints(12, 1, "Hz");

	while(1)
	{
		counter_data_init();
		ct_mode_init();
		delay1_25s();				//ʱ1.25sȴ
		x = ((unsigned long)(counter) << 16) + TH0 * 256 + TL0;	//Ƶf
		x <<= k_val;
		y = x;						//Ƶf
		
		while(x / 10)				//Ƶfλ
		{
			dat[i] = x % 10;
			x /= 10;
			i++;
		}
		dat[i] = x;
		LCD_printd(4, 1, dat, 8);	//ʾƵf
		
		counter_data_init();		//ݳʼ
		if(y == 0);
		else y = 1000000000 / y;	//T
		while(y / 10)				//ƵTλ
		{
			dat[i] = y % 10;
			y /= 10;
			i++;
		}
		dat[i] = y;
		LCD_printd(4, 0, dat, 8);	//ʾT
		key_pro();
	}
}


/*--------------------------------------------------------------*/
//T0жϷ
void T0_counter(void) interrupt 1 using 1
{
	counter++;
}


/*--------------------------------------------------------------*/
//ʱT1жϷ
void T1_timer(void) interrupt 3 using 3
{
	num++;
	if(num == 15598) {TH1 = 0x05;}		//
	if(num == 16000) {TR0 = 0; TR1 = 0;}
}




