/*--------------------------------------------------------------*/
//File:	LCD1602_8A.H
//Date:	08-8-9	//08-8-8	//08-8-27		//08-8-26
//Time:	20:10
//Modi:	08-8-10	9:51
//Note:	LCD1602	The Best Driver for you!
//		Welcome to use. Have a good day!


/*--------------------------------------------------------------*/ 
//ֹظ
#ifndef __LCD1602_8A_H__			
#define __LCD1602_8A_H__
//ͷļ
#include <intrins.h>


/*--------------------------------------------------------------*/ 
//LCD1602뵥Ƭӿڶ
sfr		LCD_IO = 0xa0;			//P0-0x80,P1-0x90,P2-0xA0,P3-0xB0;
sbit	LCD_RS = P1^0;			//LCD/ѡ(H/L)
sbit	LCD_RW = P1^1;			//LCD  /д  ѡ(H/L)
sbit	LCD_EN = P1^2;			//LCDʹܿƶ
sbit	LCD_BZ = LCD_IO^7;		//LCDæ־λ

unsigned char code blank[]={"        "};

/*--------------------------------------------------------------*/ 
//
void LCD_busy  (void);													//LCDǷæ
void LCD_init  (void);													//LCDʼ
void LCD_clr   (void);													//LCD
void LCD_cmd   (unsigned char cmd);										//дָ
void LCD_dat   (unsigned char dat);										//д
void LCD_pos   (unsigned char x, unsigned char y);						//ʾλ
void LCD_printc(unsigned char x, unsigned char y, unsigned char c);		//λַ
void LCD_prints(unsigned char x, unsigned char y, unsigned char *s);	//λַ


/*--------------------------------------------------------------*/ 
//LCDæ״̬
void LCD_busy(void)
{
	do
	{
		LCD_EN = 0;
		LCD_RS = 0;			//ָ
		LCD_RW = 1;			//
//		LCD_IO = 0xff;		//P0ھҪ	
		LCD_EN = 1;
		_nop_();			//ߵƽ	ӳʱ1us
	}while(LCD_BZ);			//LCD_BZ=1ʾæ,LCD_BZ=0ʾ
	LCD_EN = 0;
}


/*--------------------------------------------------------------*/ 
//дָ
void LCD_cmd(unsigned char cmd)			
{
	LCD_busy();				//æ
	LCD_RS = 0;				//ָ
	LCD_RW = 0;				//д
	LCD_EN = 1;
	LCD_IO = cmd;			//ָ
	LCD_EN = 0;				//½Ч
}


/*--------------------------------------------------------------*/ 
//д
void LCD_dat(unsigned char dat)	
{
	LCD_busy();				//æ
	LCD_RS = 1;				//
	LCD_RW = 0;				//д
	LCD_EN = 1;
	LCD_IO = dat;			//
	LCD_EN = 0;				//½Ч
}


/*--------------------------------------------------------------*/ 
//ʾλ
void LCD_pos(unsigned char x, unsigned char y)
{
	if(y)	LCD_cmd(x|0xc0);//y=1ڶʾ,y=0һʾ	0<=x<16
	else	LCD_cmd(x|0x80);//ָ=80+ַ(00H~27H,40H~67H)
}


/*--------------------------------------------------------------*/ 
//LCD
void LCD_clr(void)
{
	LCD_cmd(0x01);
}


/*--------------------------------------------------------------*/ 
//λַ
void LCD_printc(unsigned char x, unsigned char y, unsigned char c)
{
	LCD_pos(x,y);
	LCD_dat(c);
}


/*--------------------------------------------------------------*/ 
//λַ
void LCD_prints(unsigned char x, unsigned char y, unsigned char *s)
{
	LCD_pos(x,y);
	while(*s)
	{
		LCD_dat(*s);
		s++;
	}
}


/*--------------------------------------------------------------*/ 
//λ֣
void LCD_printd(unsigned char x, unsigned char y, unsigned char *s, unsigned char n)
{
	unsigned char i;
	LCD_pos(x, y);
	n -= 1;
	for(i = 0; i <= n; i++)
	{
		if(s[n-i] == 0)	continue;
		else			break;
	}
	LCD_prints(x, y, blank);
	LCD_pos(x+i, y);
	while(i <= n)	
	{
		LCD_dat(s[n-i] + 48);
		i++;
	}
}


/*--------------------------------------------------------------*/ 
//LCDʼ
void LCD_init(void)
{
	LCD_cmd(0x38);			//LCDΪ16X2ʾ,5X7,λݽӿ	
	LCD_cmd(0x06);			//LCDʾƶ(ַָ1,ʾƶ)
	LCD_cmd(0x0c);			//LCDʾ(겻˸,ʾ"_")
	LCD_cmd(0x01);			//
}


/*--------------------------------------------------------------*/ 
#endif





